/*
 * main.h
 *
 * Created: 05.01.2015 19:37:04
 *  Author: sschultewolter
 */ 


#ifndef MAIN_H_
#define MAIN_H_

#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdlib.h>

/************************************************************************/
/* Allgmein                                                             */
/************************************************************************/
#define	OFF				0
#define ON				1
#define TOGGLE			2

/************************************************************************/
/* HC595                                                                */
/************************************************************************/
#define HC595_DDR		DDRA
#define HC595_PORT		PORTA
#define HC595_MOSI		PORTA6
#define HC595_SS		PORTA7
#define HC595_SCK		PORTA4

/************************************************************************/
/* PWM Motor                                                            */
/************************************************************************/
#define MOTOR_DDR		DDRA
#define MOTOR_PORT		PORTA2
#define ALT_MOTOR_PORT	PORTA3
#define MOTOR_PWM		OCR1A
#define MOTOR_PWM_MIN	55
#define MOTOR_PWM_MAX	255
#define MOTOR_ON		TCCR1A |= (1<<COM1A1)
#define MOTOR_OFF		TCCR1A &= ~(1<<COM1A1)

/************************************************************************/
/* Prototypen                                                           */
/************************************************************************/
// 1ms Timer
volatile uint32_t millis;
uint32_t time(void);

void time_init(void);

// HC595
void hc595_init(void);

// PWM Motor
void motor_init(void);

#endif /* MAIN_H_ */